﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace IK
{
    class IterationsMetricMap : RangedMetricMap<int>
    {
        public IterationsMetricMap(int min, int max)
            : base(min, max)
        { }


        public override Color Colourise(Result result)
        {
            if (!result.Reached) {
                return Color.Black;
            } else if (result.Iterations == 0) {
                return Color.White;
            } else {
                double value = Maths.CLerp(result.Iterations, Min, Max);
                return ColorHelper.HSVtoRGB((1.0 - value) * 240.0, 1, 1);
            }
        }
    }
}
