﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace System.Collections.Generic
{
    public static class EnumerableHelper
    {
        public static IEnumerable<T> Generate<T>(T seed, Func<T, T> generator)
        {
            while (true) {
                yield return seed;
                seed = generator(seed);
            }
        }

        public static IEnumerable<T> Generate<T>(T seed, Func<T, T> generator, Func<T, bool> predicate)
        {
            while (predicate(seed)) {
                yield return seed;
                seed = generator(seed);
            }
        }
    }
}
